searchNodes=[{"doc":"Generates a parser from ABNF definition - text (:abnf) or file path (:abnf_file)An entry rule can be defined by :parse. If defined, a parse/1 function and a parse!/1 function will be generated with the entry rule.By default, every chunk defined by a rule is wrapped (in list) and tagged by the rulename. Use the options to :untag, :unwrap or both (:unbox).Parsed chunks (rules) can be discarded :ignore.Transformations (:map, :reduce, :replace) can be applied by passing in a :transform map with keys being rulenames and values being 2-tuples of transformation type (:map, :reduce, :replace), and mfa tuple (for :map and reduce) or a literal value (for :replace)Example usage:defmodule JsonParser do use AbnfParsec, abnf_file: &quot;test/fixture/json.abnf&quot;, parse: :json_text, transform: %{ &quot;string&quot; =&gt; {:reduce, {List, :to_string, []}}, &quot;int&quot; =&gt; [{:reduce, {List, :to_string, []}}, {:map, {String, :to_integer, []}}], &quot;frac&quot; =&gt; {:reduce, {List, :to_string, []}}, &quot;null&quot; =&gt; {:replace, nil}, &quot;true&quot; =&gt; {:replace, true}, &quot;false&quot; =&gt; {:replace, false} }, untag: [&quot;member&quot;], unwrap: [&quot;int&quot;, &quot;frac&quot;], unbox: [ &quot;JSON-text&quot;, &quot;null&quot;, &quot;true&quot;, &quot;false&quot;, &quot;digit1-9&quot;, &quot;decimal-point&quot;, &quot;escape&quot;, &quot;unescaped&quot;, &quot;char&quot; ], ignore: [ &quot;name-separator&quot;, &quot;value-separator&quot;, &quot;quotation-mark&quot;, &quot;begin-object&quot;, &quot;end-object&quot;, &quot;begin-array&quot;, &quot;end-array&quot; ] end json = ~s| {&quot;a&quot;: {&quot;b&quot;: 1.2, &quot;c&quot;: [true]}, &quot;d&quot;: null, &quot;e&quot;: &quot;e\\te&quot;} | JsonParser.json_text(json) # or JsonParser.parse(json) # =&gt; {:ok, ...} JsonParser.parse!(json) # =&gt; [ object: [ [ string: [&quot;a&quot;], value: [ object: [ [string: [&quot;b&quot;], value: [number: [int: 1, frac: &quot;.2&quot;]]], [string: [&quot;c&quot;], value: [array: [value: [true]]]] ] ] ], [string: [&quot;d&quot;], value: [nil]], [string: [&quot;e&quot;], value: [string: [&quot;e\\te&quot;]]] ] ]","ref":"AbnfParsec.html","title":"AbnfParsec","type":"module"},{"doc":"All rules by default are wrapped and tagged. See NimbleParsec for more details.Options::abnf (binary) - ABNF directly in string data:abnf_file (binary) - ABNF file path:debug (boolean) - whether to output generated parser code:skip (rulenames) - rules to be skipped when generating parser codeso user can define their own parsec definition:ignore (rulenames) - rules to be discarded after being parsed:untag (rulenames) - rules to be wrapped only after being parsed:unwrap (rulenames) - rules to be tagged only after being parsedneeds to be sure that there is only singular parsed entry:unbox (rulenames) - made up term, to both untag and unwrap:transform (transformations) - a map of rulenames to transformations{:map, mfa}{:reduce, mfa}{:replace, val}{:post_traverse, mfa}{:pre_traverse, mfa}:parse (atom) - described in module doc, needs to be an atom that is in normalized form of its original string rulename","ref":"AbnfParsec.html#__using__/1","title":"AbnfParsec.__using__/1","type":"macro"},{"doc":"","ref":"AbnfParsec.html#t:rulename/0","title":"AbnfParsec.rulename/0","type":"type"},{"doc":"","ref":"AbnfParsec.html#t:rulenames/0","title":"AbnfParsec.rulenames/0","type":"type"},{"doc":"","ref":"AbnfParsec.html#t:transformation/0","title":"AbnfParsec.transformation/0","type":"type"},{"doc":"","ref":"AbnfParsec.html#t:transformations/0","title":"AbnfParsec.transformations/0","type":"type"},{"doc":"Abnf Parser.","ref":"AbnfParsec.Parser.html","title":"AbnfParsec.Parser","type":"module"},{"doc":"Parses the given binary as alternation.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the alternation (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#alternation/2","title":"AbnfParsec.Parser.alternation/2","type":"function"},{"doc":"Parses the given binary as char_val.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the char_val (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#char_val/2","title":"AbnfParsec.Parser.char_val/2","type":"function"},{"doc":"Parses the given binary as comment.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the comment (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#comment/2","title":"AbnfParsec.Parser.comment/2","type":"function"},{"doc":"Parses the given binary as concatenation.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the concatenation (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#concatenation/2","title":"AbnfParsec.Parser.concatenation/2","type":"function"},{"doc":"Parses the given binary as core_rule.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the core_rule (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#core_rule/2","title":"AbnfParsec.Parser.core_rule/2","type":"function"},{"doc":"Parses the given binary as element.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the element (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#element/2","title":"AbnfParsec.Parser.element/2","type":"function"},{"doc":"Extension: Used in RFC3501","ref":"AbnfParsec.Parser.html#exception/2","title":"AbnfParsec.Parser.exception/2","type":"function"},{"doc":"Parses the given binary as group.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the group (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#group/2","title":"AbnfParsec.Parser.group/2","type":"function"},{"doc":"","ref":"AbnfParsec.Parser.html#normalize/1","title":"AbnfParsec.Parser.normalize/1","type":"function"},{"doc":"Parses the given binary as num_val.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the num_val (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#num_val/2","title":"AbnfParsec.Parser.num_val/2","type":"function"},{"doc":"Parses the given binary as option.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the option (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#option/2","title":"AbnfParsec.Parser.option/2","type":"function"},{"doc":"","ref":"AbnfParsec.Parser.html#parse/1","title":"AbnfParsec.Parser.parse/1","type":"function"},{"doc":"","ref":"AbnfParsec.Parser.html#parse!/1","title":"AbnfParsec.Parser.parse!/1","type":"function"},{"doc":"Parses the given binary as prose_val.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the prose_val (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#prose_val/2","title":"AbnfParsec.Parser.prose_val/2","type":"function"},{"doc":"Parses the given binary as repetition.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the repetition (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#repetition/2","title":"AbnfParsec.Parser.repetition/2","type":"function"},{"doc":"Parses the given binary as rule.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the rule (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#rule/2","title":"AbnfParsec.Parser.rule/2","type":"function"},{"doc":"Parses the given binary as rulelist.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the rulelist (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#rulelist/2","title":"AbnfParsec.Parser.rulelist/2","type":"function"},{"doc":"Parses the given binary as rulename.Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the rulename (start position) as {line, column_on_line}.Options:byte_offset - the byte offset for the whole binary, defaults to 0:line - the line and the byte offset into that line, defaults to {1, byte_offset}:context - the initial context value. It will be converted to a map","ref":"AbnfParsec.Parser.html#rulename/2","title":"AbnfParsec.Parser.rulename/2","type":"function"},{"doc":"","ref":"AbnfParsec.LeftoverTokenError.html","title":"AbnfParsec.LeftoverTokenError","type":"exception"},{"doc":"","ref":"AbnfParsec.UnexpectedTokenError.html","title":"AbnfParsec.UnexpectedTokenError","type":"exception"}]